searchData={"items":[{"type":"module","title":"Authentication","doc":"","ref":"Authentication.html"},{"type":"function","title":"Authentication.definition/0","doc":"","ref":"Authentication.html#definition/0"},{"type":"module","title":"ExMachine","doc":"","ref":"ExMachine.html"},{"type":"function","title":"ExMachine.dispatch/2","doc":"","ref":"ExMachine.html#dispatch/2"},{"type":"function","title":"ExMachine.init/2","doc":"","ref":"ExMachine.html#init/2"},{"type":"module","title":"ExMachine.Context","doc":"","ref":"ExMachine.Context.html"},{"type":"function","title":"ExMachine.Context.delete/2","doc":"Delete a key from the context.\nSame as Map.delete/2, useful because its imported in state module","ref":"ExMachine.Context.html#delete/2"},{"type":"function","title":"Examples - ExMachine.Context.delete/2","doc":"iex> context = put(%{}, :hello, :world)\n    iex> context[:hello]\n    :world\n    iex> context = delete(context, :hello)\n    iex> context[:hello]\n    nil","ref":"ExMachine.Context.html#delete/2-examples"},{"type":"function","title":"ExMachine.Context.delete_params/1","doc":"","ref":"ExMachine.Context.html#delete_params/1"},{"type":"function","title":"ExMachine.Context.get/3","doc":"Get the value of key in context.\nSame as Map.get/3, useful because its imported in state module","ref":"ExMachine.Context.html#get/3"},{"type":"function","title":"Examples - ExMachine.Context.get/3","doc":"iex> context = put(%{}, :hello, :world)\n    iex> get(context, :hello)\n    :world","ref":"ExMachine.Context.html#get/3-examples"},{"type":"function","title":"ExMachine.Context.get_params/1","doc":"","ref":"ExMachine.Context.html#get_params/1"},{"type":"function","title":"ExMachine.Context.put/3","doc":"Puts the given value under key in context.\nSame as Map.put/3, useful because its imported in state module","ref":"ExMachine.Context.html#put/3"},{"type":"function","title":"Examples - ExMachine.Context.put/3","doc":"iex> context = put(%{}, :hello, :world)\n    iex> context[:hello]\n    :world","ref":"ExMachine.Context.html#put/3-examples"},{"type":"function","title":"ExMachine.Context.put_params/2","doc":"Puts the given term under the event params key in context.","ref":"ExMachine.Context.html#put_params/2"},{"type":"function","title":"ExMachine.Context.raise_event/2","doc":"Raise an internal event during the execution of an action","ref":"ExMachine.Context.html#raise_event/2"},{"type":"module","title":"ExMachine.Final","doc":"","ref":"ExMachine.Final.html"},{"type":"type","title":"ExMachine.Final.t/0","doc":"","ref":"ExMachine.Final.html#t:t/0"},{"type":"module","title":"ExMachine.History","doc":"","ref":"ExMachine.History.html"},{"type":"type","title":"ExMachine.History.t/0","doc":"","ref":"ExMachine.History.html#t:t/0"},{"type":"module","title":"ExMachine.Machine","doc":"","ref":"ExMachine.Machine.html"},{"type":"function","title":"ExMachine.Machine.dispatch/2","doc":"Dispatch an event to the machine, performing all the necessary activities\nand returning the machine in the new active configuration.\n\nIf during execution some activities raises internal events, the machine\ncontinues execution of these events until the internal queue is empty\n(run to completion)","ref":"ExMachine.Machine.html#dispatch/2"},{"type":"function","title":"ExMachine.Machine.get_active_states/1","doc":"Returns list of currents active states.\n\nGenerally, there is only one active state if the machine is not in a parallel\n(orthogonal) state, otherwise its the list of active states\nof each active region","ref":"ExMachine.Machine.html#get_active_states/1"},{"type":"function","title":"ExMachine.Machine.init/2","doc":"Initialize the machine, performing all the necessary activities\nand returning the machine in its initial active configuration\n\nThe log of the transition to initial state are recorded in the first\nMacrostep","ref":"ExMachine.Machine.html#init/2"},{"type":"function","title":"ExMachine.Machine.last_macrostep/1","doc":"Returns last executed macrostep","ref":"ExMachine.Machine.html#last_macrostep/1"},{"type":"function","title":"ExMachine.Machine.last_microsteps/1","doc":"Returns last executed list of microstep","ref":"ExMachine.Machine.html#last_microsteps/1"},{"type":"function","title":"ExMachine.Machine.last_transitions/1","doc":"Returns last executed list of transitions","ref":"ExMachine.Machine.html#last_transitions/1"},{"type":"function","title":"ExMachine.Machine.new/2","doc":"","ref":"ExMachine.Machine.html#new/2"},{"type":"type","title":"ExMachine.Machine.t/0","doc":"","ref":"ExMachine.Machine.html#t:t/0"},{"type":"module","title":"ExMachine.Macrostep","doc":"(From SCXML): A macrostep consists of a sequence (a chain) of microsteps,\nat the end of which the state machine is in a stable state and ready\nto process an external event.\nEach external event causes an SCXML state machine to take\nexactly one macrostep.\nHowever, if the external event does not enable any transitions,\nno microstep will be taken, and the corresponding macrostep will be empty.\n\n(From SISMIC): A macro step corresponds to the process of\nconsuming an event, regardless of the number and the type\n(eventless or not) of triggered transitions.\nA macro step also includes every consecutive stabilization step\n(i.e., the steps that are needed to enter nested states,\nor to switch into the configuration of a history state).\n\nNOTE: microsteps list in in reverse order of execution, so the first\nin list is the last executed. This is for performance reason\nconsidered that lists are LIFO structure.","ref":"ExMachine.Macrostep.html"},{"type":"function","title":"ExMachine.Macrostep.new/0","doc":"","ref":"ExMachine.Macrostep.html#new/0"},{"type":"type","title":"ExMachine.Macrostep.t/0","doc":"","ref":"ExMachine.Macrostep.html#t:t/0"},{"type":"module","title":"ExMachine.Microstep","doc":"Trace and record an execution step in the statechart\n\n(From SCXML): A microstep involves the processing of a single transition\n(or, in the case of parallel states, a single set of transitions.)\nA microstep may change the active configuration, update the data\nmodel and/or generate new (internal and/or external) events.\nThis, by causality, may in turn enable additional transitions which\nwill be handled in the next microstep in the sequence, and so on.\n\n(From SISMIC): The smallest, atomic step that a statechart can execute.\nA step consider event, takes a transition and results in a list of\nentered states and a list of exited states.\nOrder in the two lists is REALLY important!\n\nParameters:\n* `event`: event or `nil` in case of eventless transition.\nIf event has parameters the term is in the form {event, params}\n* `transition`: a Transition or `nil` if no processed transition\n* `entered`: possibly empty list of entered states\n* `exited`: possibly empty list of exited states\n* `actions`: a possibly empty list of actions that are executed during the step","ref":"ExMachine.Microstep.html"},{"type":"function","title":"ExMachine.Microstep.new/0","doc":"","ref":"ExMachine.Microstep.html#new/0"},{"type":"type","title":"ExMachine.Microstep.t/0","doc":"","ref":"ExMachine.Microstep.html#t:t/0"},{"type":"module","title":"ExMachine.ServerMachine","doc":"","ref":"ExMachine.ServerMachine.html"},{"type":"module","title":"ExMachine.State","doc":"Module for defining a state in a statechart.\n\nA state is the main building block of a statechart and is itself\na statechart (the root state of a hierarchy of states).\nTypically a state is made up of one or more substates, each one a simple\nstate or composed by another substates and so on.\n\nA substate can be totally defined in the State definition or can reference a\nState defined in other module (state composability)\n\nExStatechart support the following type of state:\n* `:simple`\n* `:composite`\n* `:final` pseudostate\n* `choice`???\n\nWhen you define a state module, you must supply a well formed state definition\nthrough the `:definition` options, in the `use ExStatechart.State`.\nThe definition is loaded and verified at compile time and without\nthis definition the state is unusable.","ref":"ExMachine.State.html"},{"type":"type","title":"ExMachine.State.t/0","doc":"","ref":"ExMachine.State.html#t:t/0"},{"type":"module","title":"ExMachine.Statechart","doc":"Statechart is the internal struct powering the state machine and provides\nbase function to compile a statechart.\n\nA statechart is builded passing a valid defined State struct to the\nthe `build/1` function.\n\n* `states`: a map of all the states in the statechart\n* `configuration`: the active configuration (the current state of the machine)\nwhen the statechart is running\n* `running`: `true` if the statechart is started\n* `macrosteps`: a list of `Macrostep` struct representing the whole history of\nthe state machine, from the start to last transition (the head of the list)\n\nA configuration is a list of lists: each inner list represents an\northogonal region of the statechart. The elements in each list are\nthe active states, from deeper state (the simple or leaf state) up to\nthe root state (always \"root\").\nFor example:\n    [[\"r11\", \"r1\", \"root\"], [\"s211\", \"s21\", \"s2\", \"root\"]]","ref":"ExMachine.Statechart.html"},{"type":"function","title":"ExMachine.Statechart.build/1","doc":"Build and return a `Statechart` struct that contains the compiled and\nvalidated version of the statechart in `definition` argument,\nready to be executed in a Machine.\n\nDuring compilation, Statechart verifies that the definition is valid and raise\nan exception if there is a problem.","ref":"ExMachine.Statechart.html#build/1"},{"type":"function","title":"Examples - ExMachine.Statechart.build/1","doc":"iex> eng = Statechart.build(%State{initial: \"s1\", substates: %{ \"s1\" => %State{}}})\n    iex> Enum.count(eng.states)\n    2\n\n    iex> Statechart.build(\"invalid\")\n    ** (ExMachine.Statechart.InvalidDefinition) Definition \"invalid\" is not valid\n\n    iex> defs = %State{initial: \"invalid_state\", substates: %{ \"s1\" => %State{}}}\n    iex> Statechart.build(defs)\n    ** (ExMachine.Statechart.NotValidInitial) Initial state \"invalid_state\" is not valid or not a descendant of composite state \"root\"","ref":"ExMachine.Statechart.html#build/1-examples"},{"type":"function","title":"ExMachine.Statechart.find_lcca/2","doc":"Return the Least Common Compound Ancestor of `states` list.\n\nLCCA of a list `states` is the lowest (i.e. deepest) state in the state\nhierarchy that has all state in `states` as descendants.\n\nIn other words LCCA is the state `s` such that `s` is a ancestor of all\nstates on `states` list and no descendants of `s` has this property.\n\nReturn `nil` if in the `states` list is present the root state because can't\nexist a state that is parent of root state.\n\nNote that since we are speaking of ancestor (parent or parent\nof a parent, etc.) the LCCA is never a member of `state` list.","ref":"ExMachine.Statechart.html#find_lcca/2"},{"type":"function","title":"ExMachine.Statechart.get_ancestors/2","doc":"Returns the ancestors of `state` (parent of state, parent of parent, etc),\nin form of a list of string, ordered from nearest parent to (and always)\nthe \"root\" state.","ref":"ExMachine.Statechart.html#get_ancestors/2"},{"type":"function","title":"Examples - ExMachine.Statechart.get_ancestors/2","doc":"iex> defs = %State{initial: \"s1\", substates: %{ \"s1\" => %State{ initial: \"s11\", substates: %{ \"s11\" => %State{}}}}}\n    iex> eng = Statechart.build(defs)\n    iex> Statechart.get_ancestors(eng, \"s11\")\n    [\"s1\", \"root\"]","ref":"ExMachine.Statechart.html#get_ancestors/2-examples"},{"type":"function","title":"ExMachine.Statechart.get_ancestors_until/3","doc":"Returns the ancestors of `state` (parent of state, parent of parent, etc),\nin form of a list of string, ordered from nearest parent to (and excluded)\nthe `until` state.","ref":"ExMachine.Statechart.html#get_ancestors_until/3"},{"type":"function","title":"Examples - ExMachine.Statechart.get_ancestors_until/3","doc":"iex> defs = %State{initial: \"s1\", substates: %{ \"s1\" => %State{ initial: \"s11\", substates: %{ \"s11\" => %State{}}}}}\n    iex> eng = Statechart.build(defs)\n    iex> Statechart.get_ancestors_until(eng, \"s11\", \"root\")\n    [\"s1\"]","ref":"ExMachine.Statechart.html#get_ancestors_until/3-examples"},{"type":"function","title":"ExMachine.Statechart.get_descendants/2","doc":"Returns the descendants of `state`, in form of an unordered MapSet of string,\ncontaining all the descendants (children, children of children, etc) of `state`.","ref":"ExMachine.Statechart.html#get_descendants/2"},{"type":"function","title":"Examples - ExMachine.Statechart.get_descendants/2","doc":"iex> defs = %State{initial: \"s1\", substates: %{ \"s1\" => %State{ initial: \"s11\", substates: %{ \"s11\" => %State{}}}}}\n    iex> eng = Statechart.build(defs)\n    iex> Statechart.get_descendants(eng, \"root\")\n    MapSet.new([\"s1\", \"s11\"])","ref":"ExMachine.Statechart.html#get_descendants/2-examples"},{"type":"function","title":"ExMachine.Statechart.get_entering_states/3","doc":"Returns a list of states that must be entered when the machine is entering\nin the state `target`, considering the `lcca`","ref":"ExMachine.Statechart.html#get_entering_states/3"},{"type":"function","title":"ExMachine.Statechart.get_entry_actions/2","doc":"Return the list of enter actions for each state in list `states_list`,\nif defined for the state,  in the same exact order of `states_list`","ref":"ExMachine.Statechart.html#get_entry_actions/2"},{"type":"function","title":"ExMachine.Statechart.get_exit_actions/2","doc":"Return the list of exit actions for each state in list `states_list`,\nif defined for the state, in the same exact order of `states_list`","ref":"ExMachine.Statechart.html#get_exit_actions/2"},{"type":"function","title":"ExMachine.Statechart.get_exiting_states/3","doc":"Returns a list of states that must be exited when the machine is exiting\nfrom the state `source`, considering the `lcca`","ref":"ExMachine.Statechart.html#get_exiting_states/3"},{"type":"function","title":"ExMachine.Statechart.get_initials/2","doc":"Return list of initial states from argument `state` deep to a leaf state.\n\nThe function uses `:initial` key in the `%State{}` definition,\nunless it encounter a history state (to be implemented)","ref":"ExMachine.Statechart.html#get_initials/2"},{"type":"function","title":"Examples - ExMachine.Statechart.get_initials/2","doc":"iex> defs = %State{initial: \"s1\", substates: %{ \"s1\" => %State{ initial: \"s11\", substates: %{ \"s11\" => %State{}}}}}\n    iex> eng = Statechart.build(defs)\n    iex> Statechart.get_initials(eng, \"root\")\n    [\"root\", \"s1\", \"s11\"]\n    iex> Statechart.get_initials(eng, \"s1\")\n    [\"s1\", \"s11\"]","ref":"ExMachine.Statechart.html#get_initials/2-examples"},{"type":"function","title":"ExMachine.Statechart.get_transition_for/3","doc":"Return a transition map if `state` have a transition defined\nto handle `event`, otherwise `nil`","ref":"ExMachine.Statechart.html#get_transition_for/3"},{"type":"function","title":"ExMachine.Statechart.new/0","doc":"","ref":"ExMachine.Statechart.html#new/0"},{"type":"type","title":"ExMachine.Statechart.t/0","doc":"","ref":"ExMachine.Statechart.html#t:t/0"},{"type":"module","title":"ExMachine.Transition","doc":"","ref":"ExMachine.Transition.html"},{"type":"function","title":"ExMachine.Transition.new/1","doc":"","ref":"ExMachine.Transition.html#new/1"},{"type":"type","title":"ExMachine.Transition.t/0","doc":"","ref":"ExMachine.Transition.html#t:t/0"},{"type":"exception","title":"ExMachine.Machine.NotRunning","doc":"Raised when dispatching an event to a not running machine","ref":"ExMachine.Machine.NotRunning.html"},{"type":"exception","title":"ExMachine.Statechart.DuplicatedState","doc":"Raised when a state name is used more than once","ref":"ExMachine.Statechart.DuplicatedState.html"},{"type":"exception","title":"ExMachine.Statechart.InvalidDefinition","doc":"Raised when submitted an invalid definition","ref":"ExMachine.Statechart.InvalidDefinition.html"},{"type":"exception","title":"ExMachine.Statechart.NotDefinedState","doc":"Raised when a state name is used that is not defined","ref":"ExMachine.Statechart.NotDefinedState.html"},{"type":"exception","title":"ExMachine.Statechart.NotValidInitial","doc":"Raised when initial state of a composite state is not defined or is not\na descendants of the state","ref":"ExMachine.Statechart.NotValidInitial.html"},{"type":"extras","title":"ExMachine","doc":"# ExMachine\n\n[![Hex Version](https://img.shields.io/hexpm/v/ex_machine.svg)](https://hex.pm/packages/ex_machine)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ex_machine/)\n[![CI](https://github.com/carlotorrese/ex_machine/workflows/CI/badge.svg)](https://github.com/carlotorrese/ex_machine/actions)\n[![License](https://img.shields.io/hexpm/l/ex_machine.svg)](https://github.com/carlotorrese/ex_machine/blob/main/LICENSE)\n[![Development Status](https://img.shields.io/badge/status-alpha-orange.svg)](https://github.com/carlotorrese/ex_machine)\n\n> ⚠️ **Early Development Warning**: This project is in active development and the API may change. Use with caution in production environments.\n\nAn Elixir functional implementation of a finite state machine,\nbased on Statechart.\n\nExMachine is a purely functional implementation of a finite\nstate machine which definition is based on the Statechart formalism\nproposed by David Harel in 1987 and subsequently adopted by\nUnified Modelling Language as its standard for state machine definition.\n\nIt can be used as a simple library, using a function to dispatch an event to the machine,\nreceiving back the new machine, that include the new state and the modified context.\nAlternatively, it can be wrapped in a GenServer to run in a separate process\nas a real and fully independent machine, influenced by events sended to it.\n\nState machine are defined as static structures inside Elixir modules and\ncan be validated and loaded at compile time for better efficiency.\nMoreover State definitions are composable, allowing realization of\nindependent components, based on statechart.","ref":"readme.html"},{"type":"extras","title":"Statechart basics - ExMachine","doc":"The primary feature of statecharts is that\nstates can be organized in a hierarchy:  \na statechart is a state machine where each state\nin the state machine may define its own subordinate state machines,\ncalled substates.\nThose states can again define substates.\n\nMain supported statechart feature supported by ExMachine are:\n\n- [x] Entry and exit actions\n- [x] Transition actions\n- [x] Guard functions\n- [x] Extended state (context)\n- [x] Internal events (run to completion)\n- [x] Final pseudostates\n- [ ] History pseudostate\n- [ ] Choice pseudostates ()\n- [ ] Internal/external transitions ()\n\nFuture implementation:\n\n- [ ] Orthogonal regions i.e. parallel state\n\nNot supported:\n\n- [ ] Do actions","ref":"readme.html#statechart-basics"},{"type":"extras","title":"Finite State Machine - ExMachine","doc":"[Statechart](https://en.wikipedia.org/wiki/Statechart),\nor [Hierarchical State Machine](https://en.wikipedia.org/wiki/UML_state_machine),\nis a formalism to define a particular type of state machine called\n[Finite State Machine (FSM)](https://en.wikipedia.org/wiki/Finite-state_machine).\nA FSM is an abstract machine that can be in exactly one of a finite number\nof states at any given time.\nFSM can change from one state to another in response to some external inputs,\nthis changes are called transitions.\nAn FSM is defined by the complete list of its states, its initial state,\nand the conditions for each transition.","ref":"readme.html#finite-state-machine"},{"type":"extras","title":"State machine definition and execution - ExMachine","doc":"- A way to _*define*_ the machine, listing the complete set of possible\n  states and transitions\n- A way to _*execute*_ the machine, starting it from a specific definition and\n  sending changes to it to observing the consequent evolution.\n\nExMachine supplies both this parts","ref":"readme.html#state-machine-definition-and-execution"},{"type":"extras","title":"States - ExMachine","doc":"In statechart, a state can be either a _simple_ state (i.e., a normal state)\nor a _composite_ state, parent of other substates (children).\nWhen a statechart machine is in a simple state, it is also in it's parent state.\nMoreover, in a statechart, two or more composite state can be active at the\nsame time (orthogonal regions), modelling the situation in which the machine\nis made up of different independent parts, each one interacting with each other.\n\nFor statechart machine we can't say that the machine is in a state,\nbut that it is in a particular _configuration_: a set of one or more\nhierarchy of states, each one from a simple state up to the root state,\nfollowing the parent's tree.\nAll of the states in a configuration are actives at the same time.","ref":"readme.html#states"},{"type":"extras","title":"Context - ExMachine","doc":"Statechart is defined not only by the states but also by a so-called\n_extended state_:\na kind of data structure that models the world (the `context`) in which\nthe machine lives and that influences and is influenced by the\nmachine during it's evolution (transitions).\nSo the configuration of a machine at a given time must contain not only\nall active states but also the context of the machine in that time.\nThe context is the main data structure manipulated by the code executed in\nthe actions by a state machine and the output to the world.","ref":"readme.html#context"},{"type":"extras","title":"Transitions - ExMachine","doc":"A transition is a binary relation between two states of any type, that\nspecifies at which conditions the machine can move to a new configuration.\nTransitions defines how the machine react to a stimulus from the outside world\n(an event) and how it changes the machine itself.","ref":"readme.html#transitions"},{"type":"extras","title":"Events - ExMachine","doc":"Events are the way in which changes are submitted to the machine and in\nwhich this evolves from a state (configuration) to another one.\n\nAn event can induce a change in the state machine if in the statechart\ndefinition exist a transition that declares this event as a trigger.\n\nAn event can also carry some information, called event parameters,\nthat can be used by the machine to decide if the transition must be taken or\nif it must modify the context after the transition is performed.","ref":"readme.html#events"},{"type":"extras","title":"Guards - ExMachine","doc":"The transitions of a machine are influenced either by the event and\nits parameter, that by the current context.\nThese influences are made by particular functions, linked to transitions\ndefinitions, called _guard_.\nThese functions are called when transition is fired by an event,\nand perform a check against event parameters and the context, allowing or\nnegating the transition execution.\nGuard functions never modified directly the context,\nthey return only if the transition must be taken.","ref":"readme.html#guards"},{"type":"extras","title":"Actions - ExMachine","doc":"Statechart defines special functions, called _actions_, that can be performed\neach time a transition happens, changing the configuration.\nThis actions are the only way a machine can change its context and they\ncan also send other events to the machine (internal events),\nthus influencing the final configuration that the machine will take.","ref":"readme.html#actions"},{"type":"extras","title":"Installation - ExMachine","doc":"The package can be installed\nby adding `ex_statemachine` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_statemachine, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ExMachine","doc":"```elixir\n\n```","ref":"readme.html#usage"},{"type":"extras","title":"Curiosity - ExMachine","doc":"The first machine was officially turned on at 21:26:41 on 2018-10-11, italian time.\nHere is the `iex` session:\n\n```elixir\nErlang/OTP 20 [erts-9.2] [source] [64-bit] [smp:2:2] [ds:2:2:10] [async-threads:10] [hipe] [kernel-poll:false] [dtrace]\n\nInteractive Elixir (1.7.2) - press Ctrl+C to exit (type h() ENTER for help)\niex(1)> m = Machine.init(S0.statechart, %{foo: 0})\n%ExMachine.Machine{\n  configuration: [[\"s11\", \"s1\", \"root\"]],\n  context: %{bar: :baz, foo: 1},\n  statechart: %ExMachine.Statechart{...},\n  macrosteps: [\n    %ExMachine.Macrostep{\n      actions: [&S1.set_foo_one/1, &S1.add_bar_baz/1],\n      entered: [\"root\", \"s1\", \"s11\"],\n      event: nil,\n      exited: [],\n      microsteps: %ExMachine.Microstep{\n        actions: [&S1.set_foo_one/1, &S1.add_bar_baz/1],\n        entered: [\"root\", \"s1\", \"s11\"],\n        event: nil,\n        exited: [],\n        transition: nil\n      },\n      timestamp: ~N[2018-10-11 21:26:41.726698],\n      transitions: []\n    }\n  ],\n  queue: [],\n  running?: true\n}\niex(2)>\n\n```","ref":"readme.html#curiosity"},{"type":"extras","title":"Development Status & Roadmap - ExMachine","doc":"ExMachine is currently in **alpha stage**. While the core functionality is working and tested, the API may undergo changes as we gather feedback from the community.","ref":"readme.html#development-status-roadmap"},{"type":"extras","title":"Current State - ExMachine","doc":"- ✅ Core state machine functionality implemented\n- ✅ Statechart formalism support (hierarchical states, transitions, guards)\n- ✅ GenServer integration for process-based state machines\n- ✅ Comprehensive test suite (30+ tests)\n- ✅ Documentation and examples","ref":"readme.html#current-state"},{"type":"extras","title":"Roadmap - ExMachine","doc":"- [ ] API stabilization based on community feedback\n- [ ] Performance optimizations\n- [ ] Additional guard and action features\n- [ ] More comprehensive examples and tutorials\n- [ ] Integration with other Elixir/OTP patterns","ref":"readme.html#roadmap"},{"type":"extras","title":"Contributing - ExMachine","doc":"We welcome contributions! Please see our [contribution guidelines](CONTRIBUTING.md) and feel free to open issues or pull requests.","ref":"readme.html#contributing"},{"type":"extras","title":"Inspiration - ExMachine","doc":"- [Statecharts: a visual formalism for complex systems (David Harel)](https://ac.els-cdn.com/0167642387900359/1-s2.0-0167642387900359-main.pdf?_tid=a9d41960-080a-49d4-b051-5ed409afb933&acdnat=1538686934_8d122d2d37b601ed2f3c06a462a03fa5)\n- [SCXML](https://www.w3.org/TR/scxml/)\n- [StateX: a state management library for modern web applications](https://github.com/rintoj/statex)\n- [The World of Statechart](https://statecharts.github.io/)\n- [SISMIC Interactive Statechart Model Interpreter and Checker](https://github.com/AlexandreDecan/sismic)\n- [UML State Machine](https://www.omg.org/spec/UML/About-UML/)","ref":"readme.html#inspiration"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.1.2] - 2025-06-09","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated README documentation and project configuration\n- Refined project settings and documentation\n\n## [0.1.1] - 2025-06-09","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Development status indicators and badges\n- Early development warning in README\n- Comprehensive contributing guidelines (CONTRIBUTING.md)\n- Project roadmap and current state documentation\n- Alpha status indication in package description","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated README with development status badges\n- Enhanced documentation for contributors\n\n## [0.1.0-alpha] - 2025-06-09","ref":"changelog.html#changed-1"},{"type":"extras","title":"Added - Changelog","doc":"- **Alpha Release**: Initial release of ExMachine functional state machine library\n- Complete implementation of Statechart-based finite state machine\n- Support for hierarchical states with parent-child relationships\n- Entry and exit actions for state transitions\n- Transition actions with custom logic\n- Guard functions for conditional transitions\n- Extended state management (context)\n- Internal events with run-to-completion semantics\n- Final pseudostates for termination\n- Comprehensive test suite with 30 tests\n- Sample implementations (S0, S1, S2, Authentication)\n- Complete documentation with doctests\n- Modern Elixir 1.16.1 and Erlang 26.2.2 support","ref":"changelog.html#added-1"},{"type":"extras","title":"Technical Details - Changelog","doc":"- Purely functional implementation\n- Compile-time validation of state machine definitions\n- Composable state definitions across modules\n- GenServer integration for process-based execution\n- Macrostep and microstep execution tracking\n- Full compatibility with modern Elixir ecosystem","ref":"changelog.html#technical-details"},{"type":"extras","title":"Dependencies - Changelog","doc":"- ex_doc ~> 0.31 (documentation generation)\n- dialyxir ~> 1.4 (static analysis)\n\n[Unreleased]: https://github.com/YOUR_USERNAME/ex_machine/compare/v0.1.0...HEAD\n[0.1.0]: https://github.com/YOUR_USERNAME/ex_machine/releases/tag/v0.1.0","ref":"changelog.html#dependencies"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2018-2025 Restore srl\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}